#include "stdafx.h"
#include "Dictionary.h"


extern FILE *listing, *binary;

extern int lineNum;
extern bool newline;
void DIE(char *msg);
int here;
bool nonEmptyLine;
CString GetWord(void);
void SkipLine(void);
__int16 program[10000];
int ifLev = 0;
int ifAddr[100];

const int Return  = 60000;
const int Literal = 60016;
const int JumpZ   = 60247;
const int JumpNZ  = 60248;
const int Jump    = 60249;


 struct SYSWORD
 {
   char *name;
   int  val;
 };

 SYSWORD systemWords[] = 
 {

    "StdBltShape"                       ,60001,
    "StdDrawWallText"                   ,60002,
    "StdDrawWallDecoration"             ,60003,
    "StdDrawFloorDecoration"            ,60004,
    "StdDrawCeilingPit"                 ,60005,
    "StdDrawRoomObjects"                ,60006,
    //
    "wallDecorationLeft"                ,60007,
    "wallDecorationFront"               ,60008,
    "wallDecorationRight"               ,60009,
    //
    "StdBltShapeToViewport"             ,60010,
    //
    "DoorSwitch"                        ,60011,
    "StdDrawDoorSwitch"                 ,60012,
    "SeeThroughWalls"                   ,60013,
    "StdDrawSeeThruDoorEdge"            ,60014,
    "GetDecoration0"                    ,60015,
    //
    "Literal"                           ,60016,
    //
    "StdMirrorShapeToViewport"          ,60017,
    "StdMirrorGraphicToViewport"        ,60018,
    "StdGraphicToViewport"              ,60019,
    "StdDrawTeleporter"                 ,60020,
    //
    "StdStairFacingUpRectangleF3L1"     ,60021,
    "StdStairFacingUpRectangleF3"       ,60022,
    "StdStairFacingUpRectangleF3R1"     ,60023,
    "StdStairFacingUpRectangleF2L1"     ,60024,
    "StdStairFacingUpRectangleF2"       ,60025,
    "StdStairFacingUpRectangleF2R1"     ,60026,
    "StdStairFacingUpRectangleF1L1"     ,60027,
    "StdStairFacingUpRectangleF1"       ,60028,
    "StdStairFacingUpRectangleF1R1"     ,60029,
    "StdStairFacingUpRectangleF0L"      ,60030,
    "StdStairFacingUpRectangleF0R"      ,60031,
    "StdStairFacingDownRectangleF3L1"   ,60032,
    "StdStairFacingDownRectangleF3"     ,60033,
    "StdStairFacingDownRectangleF3R1"   ,60034,
    "StdStairFacingDownRectangleF2L1"   ,60035,
    "StdStairFacingDownRectangleF2"     ,60036,
    "StdStairFacingDownRectangleF2R1"   ,60037,
    "StdStairFacingDownRectangleF1L1"   ,60038,
    "StdStairFacingDownRectangleF1"     ,60039,
    "StdStairFacingDownRectangleF1R1"   ,60040,
    "StdStairFacingDownRectangleF0L"    ,60041,
    "StdStairFacingDownRectangleF0R"    ,60042,
    //
    "FloorDecorationGraphicOrdinalF4L1" ,60043,
    "FloorDecorationGraphicOrdinalF4"   ,60044,
    "FloorDecorationGraphicOrdinalF4R1" ,60045,
    "FloorDecorationGraphicOrdinalF3L1" ,60046,
    "FloorDecorationGraphicOrdinalF3"   ,60047,
    "FloorDecorationGraphicOrdinalF3R1" ,60048,
    "FloorDecorationGraphicOrdinalF2L1" ,60049,
    "FloorDecorationGraphicOrdinalF2"   ,60050,
    "FloorDecorationGraphicOrdinalF2R1" ,60051,
    "FloorDecorationGraphicOrdinalF1L1" ,60052,
    "FloorDecorationGraphicOrdinalF1"   ,60053,
    "FloorDecorationGraphicOrdinalF1R1" ,60054,
    "FloorDecorationGraphicOrdinalF0L1" ,60055,
    "FloorDecorationGraphicOrdinalF0"   ,60056,
    "FloorDecorationGraphicOrdinalF0R1" ,60057,
    //
    "StdFloorPitRectangleF3L1"          ,60058,
    "StdFloorPitRectangleF3"            ,60059,
    "StdFloorPitRectangleF3R1"          ,60060,
    "StdFloorPitRectangleF2L1"          ,60061,
    "StdFloorPitRectangleF2"            ,60062,
    "StdFloorPitRectangleF2R1"          ,60063,
    "StdFloorPitRectangleF1L1"          ,60064,
    "StdFloorPitRectangleF1"            ,60065,
    "StdFloorPitRectangleF1R1"          ,60066,
    "StdFloorPitRectangleF0L1"          ,60067,
    "StdFloorPitRectangleF0"            ,60068,
    "StdFloorPitRectangleF0R1"          ,60069,
    //
    "StdTeleporterRectangleF3L1"        ,60070,
    "StdTeleporterRectangleF3"          ,60071,
    "StdTeleporterRectangleF3R1"        ,60072,
    "StdTeleporterRectangleF2L1"        ,60073,
    "StdTeleporterRectangleF2"          ,60074,
    "StdTeleporterRectangleF2R1"        ,60075,
    "StdTeleporterRectangleF1L1"        ,60076,
    "StdTeleporterRectangleF1"          ,60077,
    "StdTeleporterRectangleF1R1"        ,60078,
    "StdTeleporterRectangleF0L1"        ,60079,
    "StdTeleporterRectangleF0"          ,60080,
    "StdTeleporterRectangleF0R1"        ,60081,
    //
    "StdWallRectangleF3L2"              ,60082,
    "StdWallRectangleF3L1"              ,60083,
    "StdWallRectangleF3"                ,60084,
    "StdWallRectangleF3R1"              ,60085,
    "StdWallRectangleF3R2"              ,60086,
    "StdWallRectangleF2L1"              ,60087,
    "StdWallRectangleF2"                ,60088,
    "StdWallRectangleF2R1"              ,60089,
    "StdWallRectangleF1L1"              ,60090,
    "StdWallRectangleF1"                ,60091,
    "StdWallRectangleF1R1"              ,60092,
    "StdWallRectangleF0L1"              ,60093,
    "StdWallRectangleF0"                ,60094,
    "StdWallRectangleF0R1"              ,60095,
    //
    "StdDrawDoor"                       ,60096,
    //
    "F4L1xy"                            ,60097,
    "F4xy"                              ,60098,
    "F4R1xy"                            ,60099,
    "F3L2xy"                            ,60100,
    "F3L1xy"                            ,60101,
    "F3xy"                              ,60102,
    "F3R1xy"                            ,60103,
    "F3R2xy"                            ,60104,
    "F2L1xy"                            ,60105,
    "F2xy"                              ,60106,
    "F2R1xy"                            ,60107,
    "F1L1xy"                            ,60108,
    "F1xy"                              ,60109,
    "F1R1xy"                            ,60110,
    "F0L1xy"                            ,60111,
    "F0xy"                              ,60112,
    "F0R1xy"                            ,60113,
    //
    "F4L1Contents"                      ,60114,
    "F4Contents"                        ,60115,
    "F4R1Contents"                      ,60116,
    "F3L2Contents"                      ,60117,
    "F3L1Contents"                      ,60118,
    "F3Contents"                        ,60119,
    "F3R1Contents"                      ,60120,
    "F3R2Contents"                      ,60121,
    "F2L1Contents"                      ,60122,
    "F2Contents"                        ,60123,
    "F2R1Contents"                      ,60124,
    "F1L1Contents"                      ,60125,
    "F1Contents"                        ,60126,
    "F1R1Contents"                      ,60127,
    "F0L1Contents"                      ,60128,
    "F0Contents"                        ,60129,
    "F0R1Contents"                      ,60130,
    //
    "F4L1"                              ,60131,
    "F4"                                ,60132,
    "F4R1"                              ,60133,
    "F3L2"                              ,60134,
    "F3L1"                              ,60135,
    "F3"                                ,60136,
    "F3R1"                              ,60137,
    "F3R2"                              ,60138,
    "F2L1"                              ,60139,
    "F2"                                ,60140,
    "F2R1"                              ,60141,
    "F1L1"                              ,60142,
    "F1"                                ,60143,
    "F1R1"                              ,60144,
    "F0L1"                              ,60145,
    "F0"                                ,60146,
    "F0R1"                              ,60147,
    //
    "StdStairFacingDownGraphicF3L1"     ,60148,
    "StdStairFacingDownGraphicF3"       ,60149,
    "StdStairFacingDownGraphicF3R1"     ,60150,
    "StdStairFacingDownGraphicF2L1"     ,60151,
    "StdStairFacingDownGraphicF2"       ,60152,
    "StdStairFacingDownGraphicF2R1"     ,60153,
    "StdStairFacingDownGraphicF1L1"     ,60154,
    "StdStairFacingDownGraphicF1"       ,60155,
    "StdStairFacingDownGraphicF1R1"     ,60156,
    "StdStairFacingDownGraphicF0"       ,60157,
    //
    "StdStairFacingUpGraphicF3L1"       ,60158,
    "StdStairFacingUpGraphicF3"         ,60159,
    "StdStairFacingUpGraphicF3R1"       ,60160,
    "StdStairFacingUpGraphicF2L1"       ,60161,
    "StdStairFacingUpGraphicF2"         ,60162,
    "StdStairFacingUpGraphicF2R1"       ,60163,
    "StdStairFacingUpGraphicF1L1"       ,60164,
    "StdStairFacingUpGraphicF1"         ,60165,
    "StdStairFacingUpGraphicF1R1"       ,60166,
    "StdStairFacingUpGraphicF0"         ,60167,
    //
    "WallF3L1Front"                     ,60168,
    "WallF3L1Right"                     ,60169,
    "WallF3Front"                       ,60170,
    "WallF3R1Left"                      ,60171,
    "WallF3R1Front"                     ,60172,
    "WallF2L1Front"                     ,60173,
    "WallF2L1Right"                     ,60174,
    "WallF2Front"                       ,60175,
    "WallF2R1Left"                      ,60176,
    "WallF2R1Front"                     ,60177,
    "WallF1L1Right"                     ,60178,
    "WallF1Front"                       ,60179,
    "WallF1R1Left"                      ,60180,
    //
    "StdStairEdgeGraphicF2"             ,60181,
    "StdStairEdgeGraphicUpF1"           ,60182,
    "StdStairEdgeGraphicDownF1"         ,60183,
    "StdStairEdgeGraphicF0L1"           ,60184,
    "StdStairEdgeGraphicF0R1"           ,60185,
    "StdStairEdgeRectF2L1"              ,60186,
    "StdStairEdgeRectF2R1"              ,60187,
    "StdStairEdgeUpRectF1L1"            ,60188,
    "StdStairEdgeUpRectF1R1"            ,60189,
    "StdStairEdgeDownRectF1L1"          ,60190,
    "StdStairEdgeDownRectF1R1"          ,60191,
    "StdStairEdgeRectF0L1"              ,60192,
    "StdStairEdgeRectF0R1"              ,60193,
    //
    "StdDoorEdgeFrameBitmapF0"          ,60194,
    "StdDoorFacingFrameLeftBitmapF2"    ,60195,
    "StdDoorFacingFrameLeftBitmapF1"    ,60196,
    "StdDoorFacingFrameRightBitmapF1"   ,60197,
    "StdDoorFacingFrameLeftBitmapF3"    ,60198,
    "StdDoorFacingFrameLeftBitmapF3R1"  ,60199,
    "StdDoorFacingFrameLeftBitmapF3L1"  ,60200,
    "StdDoorFacingTopTrackBitmapF1"     ,60201,
    "StdDoorFacingTopTrackBitmapF2"     ,60202,
    //
    "F3L1DoorRecordIndex"               ,60203,
    "F3DoorRecordIndex"                 ,60204,
    "F3R1DoorRecordIndex"               ,60205,
    "F2L1DoorRecordIndex"               ,60206,
    "F2DoorRecordIndex"                 ,60207,
    "F2R1DoorRecordIndex"               ,60208,
    "F1L1DoorRecordIndex"               ,60209,
    "F1DoorRecordIndex"                 ,60210,
    "F1R1DoorRecordIndex"               ,60211,
    "F0DoorRecordIndex"                 ,60212,
    //
    "F3L1DoorState"                     ,60213,
    "F3DoorState"                       ,60214,
    "F3R1DoorState"                     ,60215,
    "F2L1DoorState"                     ,60216,
    "F2DoorState"                       ,60217,
    "F2R1DoorState"                     ,60218,
    "F1L1DoorState"                     ,60219,
    "F1DoorState"                       ,60220,
    "F1R1DoorState"                     ,60221,
    "F0DoorState"                       ,60222,
    //
    "StdDoorGraphicsF3"                 ,60223,
    "StdDoorGraphicsF2"                 ,60224,
    "StdDoorGraphicsF1"                 ,60225,
    //
    "StdDoorRectsF3L1"                  ,60226,
    "StdDoorRectsF3"                    ,60227,
    "StdDoorRectsF3R1"                  ,60228,
    "StdDoorRectsF2L1"                  ,60229,
    "StdDoorRectsF2"                    ,60230,
    "StdDoorRectsF2R1"                  ,60231,
    "StdDoorRectsF1L1"                  ,60232,
    "StdDoorRectsF1"                    ,60233,
    "StdDoorRectsF1R1"                  ,60234,
    "StdDoorRectsF0"                    ,60235,
    //
    "Alcove"                            ,60236,
    "HasDecoration"                     ,60237,
    "LeaveMortarJoint"                  ,60238,
    //
    "StdDoorEdgeFrameRectF0"            ,60239,
    "StdDoorFacingTopTrackRectF2L1"     ,60240,
    "StdDoorFacingTopTrackRectF2"       ,60241,
    "StdDoorFacingTopTrackRectF2R1"     ,60242,
    "StdDoorFacingTopTrackRectF1L1"     ,60243,
    "StdDoorFacingTopTrackRectF1"       ,60244,
    "StdDoorFacingTopTrackRectF1R1"     ,60245,
    "StdDoorFacingTopTrackRectF0"       ,60246,
    //
    "JumpZ"                             ,60247,
    "JumpNZ"                            ,60248,
    "Jump"                              ,60249,
    //
    "StdDoorFacingFrameRectF3L1"        ,60250,
    "StdDoorFacingFrameRectF3R1"        ,60251,
    "StdDoorFacingFrameRightRectF3"     ,60252,
    "StdDoorFacingFrameLeftRectF3"      ,60253,
    "StdDoorFacingFrameRightRectF2"     ,60254,
    "StdDoorFacingFrameLeftRectF2"      ,60255,
    "StdDoorFacingFrameRightRectF1"     ,60256,
    "StdDoorFacingFrameLeftRectF1"      ,60257,
    //
    "StdWallBitmapF3L2"                 ,60258,
    "StdWallBitmapF3L1"                 ,60259,
    "StdWallBitmapF3"                   ,60260,
    "StdWallBitmapF3R1"                 ,60261,
    "StdWallBitmapF3R2"                 ,60262,
    "StdWallBitmapF2L1"                 ,60263,
    "StdWallBitmapF2"                   ,60264,
    "StdWallBitmapF2R1"                 ,60265,
    "StdWallBitmapF1L1"                 ,60266,
    "StdWallBitmapF1"                   ,60267,
    "StdWallBitmapF1R1"                 ,60268,
    "StdWallBitmapF0L1"                 ,60269,
    "StdWallBitmapF0R1"                 ,60270,
    //
    "DrawOrder00"                       ,60271,
    "DrawOrder32"                       ,60272,
    "DrawOrder28"                       ,60273,
    "DrawOrder39"                       ,60274,
    "DrawOrder41"                       ,60275,
    "DrawOrder18"                       ,60276,
    "DrawOrder49"                       ,60277,
    "DrawOrder3421"                     ,60278,
    "DrawOrder218"                      ,60279,
    "DrawOrder349"                      ,60280,
    "DrawOrder4312"                     ,60281,
    "DrawOrder431"                      ,60282,
    "DrawOrder128"                      ,60283,
    "DrawOrder439"                      ,60284,
    "DrawOrder321"                      ,60285,
    "DrawOrder412"                      ,60286,
    "DrawOrder01"                       ,60287,
    "DrawOrder02"                       ,60288,
    "DrawOrder21"                       ,60289,
    //
    "StdAllocateDerivedGraphic"         ,60290,
    "StdBitmapViewport"                 ,60291,
    "StdBltToDerivedGraphic"            ,60292,
    "StdSeeThruWallsRect"               ,60293,
    "StdSeeThruWallsRectUByte4"         ,60294,
    "StdSeeThruWallsRectUByte6"         ,60295,
    //
    "MinusOne"                          ,60296,
    "StdHoleInWallBitmap"               ,60297,
    "Zero"                              ,60298,
    "StdDeleteDerivedGraphic"           ,60299,
    "StdBltFromDerivedGraphic"          ,60300,
    "StdSeeThruWallsRect2"              ,60301,
  
    "CurrentSkin"                       ,60302,
    "WallGraphicID"                     ,60303,
    "WallMaskID"                        ,60304,
    "CurrentCell"                       ,60305,
    "DrawCustomGraphic"                 ,60306,
    "DrawCustomDecoration"              ,60307,
    "WallDecorationID"                  ,60308,
    "FloorDecorationID"                 ,60309,
    "FloorGraphicID"                    ,60310,
    "MiddleGraphicID"                   ,60311,
    "CeilingGraphicID"                  ,60312,
    "FloorMaskID"                       ,60313,
    "MiddleMaskID"                      ,60314,
    "CeilingMaskID"                     ,60315,
    "SkinNumber"                        ,60316,
    "CreateVirtualBitmap"               ,60317,
  
    "SWAP"                              ,60318,
    "DROP"                              ,60319,
    "OVER"                              ,60320,
    "ROT"                               ,60321,
    "DUP"                               ,60322,
    "?DUP"                              ,60323,
    "PICK"                              ,60324,
    "ROLL"                              ,60325,
    "+"                                 ,60326,
    "-"                                 ,60327,
    "*"                                 ,60338,
    "/"                                 ,60339,
    "="                                 ,60340,
    "<"                                 ,60341,
    ">"                                 ,60342,
    "U<"                                ,60343,
    "0="                                ,60344,
    "0<"                                ,60345,
    "0>"                                ,60346,
    "NOT"                               ,60347,
    "AND"                               ,60348,
    "OR"                                ,60349,
    "IsOdd"                             ,60350,
    "CreateVirtualMask"                 ,60351,
    "NeedVirtualMask?"                  ,60352,
    "2DUP"                              ,60353,
    "GetMaskHeader"                     ,60356,
    ">R"                                ,60357,
    "R>"                                ,60358,
    "2Drop"                             ,60359,
    "BitmapInfo"                        ,60360,
    "CreateVirtualAffineMask"           ,60361,
    "LSHIFT"                            ,60362,
  
    "DrawOrder342"                      ,60363
 };

void CompileError(char *fmt, CString a)
{
  printf(fmt, a);
  printf("Line number %d\n", lineNum);
  DIE("Compile Terminated");
}


int SysWord(CString name)
{
  int i;
  for (i=0; i<sizeof(systemWords)/sizeof(systemWords[0]); i++)
  {
    if (name == systemWords[i].name) return systemWords[i].val;
  };
  return -1;
}

void Comma(int val)
{
  if (newline) fprintf(listing, "%05d ", here);
  newline = false;
  nonEmptyLine = true;
  fprintf(listing, "%d ",val);
  program[here++] = val;
}

void SkipComma(void)
{
  if (newline) fprintf(listing, "%05d ", here);
  newline = false;
  nonEmptyLine = true;
  fprintf(listing, "%d ",program[here++]);
}


bool Number(CString name, int *val)
{
  int i;
  *val = 0;
  for (i=0; i<name.GetLength(); i++)
  {
    if (name[i] < '0') return false;
    if (name[i] > '9') return false;
    *val = (*val * 10) + name[i] - '0';
  };
  return true;
}

void Compile(void)
{
  bool compilemode = false;
  CString word;
  int val, index;
  here = 0;
  newline = true;
  SkipComma();
  while ((word = GetWord()) != "")
  {
    if ((index = dict.FindWord(word)) >= 0)
    {
      if (!compilemode) CompileError("User-defined word outside of definition - %s\n",word);
      Comma(dict.GetVal(index));
    }
    else if ((val = SysWord(word)) >= 0)
    {
      if (!compilemode) CompileError("System word encountered outside of definition - %s\n",word);
      Comma(val);
    }
    else if (word == "//")
    {
      SkipLine();
    }
    else if (word == ":")
    {
      if (compilemode) CompileError("':' encountered in definition\n",word);
      compilemode = true;
      word = GetWord();
      if (word == "")
      {
        CompileError("Expected word name following ':'\n",word);
      };
      index = dict.FindWord(word);
      if (index >= 0)
      {
        dict.SetVal(index, here);
      }
      else
      {
        dict.NewWord(word, here);
      };
    }
    else if (word == ";")
    {
      if (!compilemode) CompileError("';' encountered outside of definition\n",word);
      Comma(Return);
      compilemode = false;
    }
    else if (word == "IF")
    {
      if (!compilemode) CompileError("'IF' encountered ouside definition\n",word);
      Comma(JumpZ);
      ifAddr[ifLev] = here;
      SkipComma();
      ifLev++;
    }
    else if (word == "ELSE")
    {
      if (!compilemode) CompileError("'ELSE' encountered ouside definition\n",word);
      if (ifLev == 0) CompileError("Unmatched 'ELSE'\n",word);
      Comma(Jump);
      program[ifAddr[ifLev-1]] = here - ifAddr[ifLev-1];
      ifAddr[ifLev-1] = here;
      SkipComma();
    }
    else if (word == "THEN")
    {
      if (!compilemode) CompileError("'THEN' encountered ouside definition\n",word);
      if (ifLev == 0) CompileError("Unmatched 'THEN'\n",word);
      --ifLev;
      program[ifAddr[ifLev]] = here - ifAddr[ifLev] - 1;
    }
    else if(Number(word,&val))
    {
      Comma(Literal);
      Comma(val);
    }
    else
    {
      CompileError("Unknown word = %s\n", word);
    };
  };
  index = dict.FindWord("main");
  if (index < 0) CompileError ("Cannot find 'main' program\n",word);
  program[0] = dict.GetVal(index);
  fwrite(program,2,here,binary);
}
         