// ViewportCompiler.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ViewportCompiler.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int here;
extern bool eof;
void Compile(void);

FILE *input, *listing, *binary;

void Usage(void)
{
  printf("Usage: \n");
  printf("   ViewportCompiler <input file> < listing file> <binary file>\n");
}

void DIE(char *msg)
{
  char line[80];
  printf("%s\n", msg);
  printf("   Press ENTER >>");
  gets(line);
  exit(1);
}


/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
    printf("Viewport Compiler Version 2.0 - 15 April 2007\n");

    if (argc != 4)
    {
      Usage();
      DIE("Improper command line");
    };
    input = fopen(argv[1],"r");
    if (input == NULL)
    {
      Usage();
      DIE("Cannot open input file");
    };
    listing = fopen(argv[2],"w");
    if (listing == NULL)
    {
      Usage();
      DIE("Cannot open listing file");
    };
    binary = fopen(argv[3],"wb");
    if (binary == NULL)
    {
      Usage();
      DIE("Cannot open binary file");
    };
    Compile();
    fseek(input,0,SEEK_SET);
    fseek(listing,0,SEEK_SET);
    fseek(binary,0,SEEK_SET);
    eof = false;
    Compile();
    fclose(input);
    fclose(listing);
    fclose(binary);
	}

	return nRetCode;
}


